// gl_order_tab.js - 2020
jQuery(function () {
    jQuery('.gl-btn-refund').on('click', function (ev) {
        ev.preventDefault();

        var form = this.closest('form'), preloader = this.querySelector('i'), button = this;

        preloader.style.display = 'inline';
        button.setAttribute('disabled', true);
        button.classList.add('disabled');

        jQuery.ajax({
            url: form.action,
            data: jQuery(form).serialize(),
            method: form.method,
            success: function (result) {
                if (result.error) {
                    var hrefCheck = (result.message).match(/href="([^"]*)/), href = "";
                    if (hrefCheck !== null)
                        href = hrefCheck[1];
                    if (href.length) {
                        if (prompt((result.message).replace(/<\/?[^>]+(>|$)/g, ""), href)) {
                            window.open(href, '_blank');
                        }
                    } else
                        alert(result.message);
                } else {
                    alert(result.message);
                }

                if (typeof result.extra === "object" && result.extra.type === 'add_to_history') {
                    document.getElementById('input-order-status').value = result.extra.order_status_id;
                    document.getElementById('input-override').checked = (result.extra.override === '1') ? true : false;
                    document.getElementById('input-notify').checked = (result.extra.notify === '1') ? true : false;
                    document.getElementById('input-comment').value = (result.extra.comment);
                    document.getElementById('button-history').click();
                }

                preloader.style.display = 'none';
                button.removeAttribute('disabled');
                button.classList.remove('disabled');
            },
            fail: function (res) {
                alert(res)
            }
        })
    })
})