class gl_payment_form_1 {

    constructor() {
        return;
    }

    init() {
        this.gl_payment_form = document.getElementById('browser3dform');
        this.gl_payment_form_cc_number = this.gl_payment_form.querySelector('input[name="number"]');
        this.gl_payment_form_cc_cvv = this.gl_payment_form.querySelector('input[name="cvc"]');
        this.gl_payment_form_holder = this.gl_payment_form.querySelector('input[name="name"]');
        this.gl_payment_form_expiry = this.gl_payment_form.querySelector('input[name="expiry"]');
        this.gl_payment_form_bin = '000000';
        this.gl_payment_form_currency = '';
        this.gl_payment_form_currencyPrefix = '';
        this.gl_payment_form_currencySuffix = '';
        this.gl_payment_form_installmenttext = '';
        this.gl_payment_form_advancetext = '';
        var _this = this;

        (this.gl_payment_form_cc_number).addEventListener('change', function () {
            _this.numberChanged(this, _this);
        });
        (this.gl_payment_form_cc_number).addEventListener('keyup', function () {
            _this.numberChanged(this, _this);
        });

        this.gl_payment_form_currency = this.gl_payment_form.dataset.currency;

        this.gl_payment_form_currencyPrefix = this.gl_payment_form.dataset.currencyprefix;
        this.gl_payment_form_currencySuffix = this.gl_payment_form.dataset.currencysuffix;

        this.gl_payment_form_installmenttext = this.gl_payment_form.dataset.installmenttext;
        this.gl_payment_form_advancetext = this.gl_payment_form.dataset.advancetext;
    };

    filterCCNumber(ccn) {
        return ccn.replace(/\s/g, '');
    };

    priceFilter(n) {
        return this.gl_payment_form_currencyPrefix + parseFloat(n).toFixed(2) + this.gl_payment_form_currencySuffix;
    };

    changedBin() {
        return (this.filterCCNumber(this.gl_payment_form_cc_number.value)).substr(0, 6) === this.gl_payment_form_bin;
    };


    numberChanged(input, parent) {

        if (typeof parent === "undefined")
            return;

        var ccnumber = parent.filterCCNumber(input.value);

        if (ccnumber.length > 6 && ccnumber.substr(0, 6) !== parent.gl_payment_form_bin) {
            parent.gl_payment_form_bin = ccnumber.substr(0, 6);
            // taksit sorgusu

            var formElement = parent.gl_payment_form;
            var installmentContainer = document.getElementById('installmentInputs');

            var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function () {
                if (this.readyState === 4 && this.status === 200) {
                    var taksitsonuc = JSON.parse(this.responseText);

                    if (taksitsonuc.status) {
                        if (typeof taksitsonuc.installment === "object") {

                            var taksval = '', takskey = '', taksitElementSpan1, taksitElementSpan2, taksitElementLabel,
                                taksitElementInput;

                            document.getElementById('installmentInputs').querySelectorAll('label').forEach(function (labelElm) {
                                labelElm.remove();
                            });

                            // parent.gl_payment_form_bin = '000000';

                            for (var index in taksitsonuc.installment) {
                                taksval = taksitsonuc.installment[index];
                                if (taksval === -1) {
                                    continue;
                                }

                                takskey = index.split('_');
                                takskey = takskey[0];

                                taksitElementSpan1 = document.createElement('span');
                                taksitElementSpan1.classList = 'installment-big';

                                taksitElementSpan2 = document.createElement('span');
                                taksitElementSpan2.classList = 'installment-amounts';

                                if (takskey > 1) {
                                    taksitElementSpan1.innerText = takskey + " " + parent.gl_payment_form_installmenttext;
                                    taksitElementSpan2.innerHTML = "<strong>" + parent.priceFilter(taksval / takskey) + "</strong>"
                                        + "x" + takskey + "<small>" + parent.priceFilter(taksval) + "</small>";

                                } else {
                                    taksitElementSpan1.innerHTML = "<strong>" + parent.gl_payment_form_advancetext + "</strong>";
                                    taksitElementSpan2.innerText = parent.priceFilter(taksval);

                                }

                                taksitElementLabel = document.createElement('label');
                                taksitElementInput = document.createElement('input');
                                taksitElementInput.name = 'installment';
                                taksitElementInput.type = 'radio';
                                if (takskey === 'advance')
                                    taksitElementInput.value = 1;
                                else
                                    taksitElementInput.value = takskey;
                                taksitElementInput.style.display = 'none';
                                taksitElementInput.id = 'gl_payment_installment_' + takskey;

                                taksitElementLabel.htmlFor = 'gl_payment_installment_' + takskey;

                                taksitElementLabel.appendChild(taksitElementInput);

                                taksitElementLabel.appendChild(taksitElementSpan1);
                                taksitElementLabel.appendChild(taksitElementSpan2);

                                installmentContainer.appendChild(taksitElementLabel);

                                installmentContainer.querySelector('label[for=gl_payment_installment_advance]').classList.add('active');
                                installmentContainer.querySelector('input[id=gl_payment_installment_advance').click();
                                taksitElementLabel.addEventListener('click', function () {

                                    document.getElementById('installmentInputs').querySelectorAll('label').forEach(function (labelElm) {
                                        labelElm.classList.remove('active');
                                    });
                                    this.querySelector('input').click();
                                    this.classList.add('active');
                                });
                            }
                        }
                    } else {
                        var msg = ((typeof taksitsonuc.message !== "undefined") ? taksitsonuc.message : error_undefined);
                        alert(msg);
                    }
                }
            };

            var
                _check_bin_url = formElement.dataset.checkbinurl,
                _amount = formElement.dataset.total,
                _installmentText = formElement.dataset.installmentText,
                _advanceText = formElement.dataset.advanceText
            ;

            _check_bin_url = _check_bin_url + ((_check_bin_url.indexOf('?') > -1) ? '&' : '?') + "amount=" + _amount + "&bin=" + parent.gl_payment_form_bin;
            xhttp.open("GET", _check_bin_url, true);
            xhttp.send();

        } else {
            if (ccnumber.length < 7) {
                document.getElementById('installmentInputs').querySelectorAll('label').forEach(function (labelElm) {
                    labelElm.remove();
                });
                parent.gl_payment_form_bin = '000000';
            }
        }
    };

}


jQuery(function () {
    gl_p_form = new gl_payment_form_1();
    gl_p_form.init();
    if ($("#quick-checkout-button-confirm").length) {
        quick_chekcout_default_text = $("#quick-checkout-button-confirm").text()
        var bexButton = document.querySelector('img[src$="bkm-button.png"]');
        if(bexButton !== null) {
            bexButton.style.display = 'none';
            var bkmJournalText = document.createElement("span")
            bkmJournalText.style.textAlign = "center"
            bkmJournalText.innerText = "İşleminize BKMExpress ile devam edilecektir. Siparişinizi tamamlayabilirsiniz."
            bkmJournalText.style.fontWeight = "bold"
            bkmJournalText.style.fontSize = 16
            bkmJournalText.style.padding = "10px 0"
            bexButton.parentNode.appendChild(bkmJournalText);
        }
        $("#button-confirm").hide();
    }
    gl_payment_gw_menu_selection();
    $("#button-confirm").on("click", function (ev) {
        ev.preventDefault();
        grilabs_payment_form_submit()
    });
});

$(document).ajaxSuccess(function (event, xhr, settings, data) {
    if ((settings.url).indexOf('journal3/checkout/save') > -1 && ((typeof data.request.get.confirm === "string" && data.request.get.confirm === "true") || (typeof data.request.get.confirm === "boolean" && data.request.get.confirm === true))) {
        if (typeof data.response.error === "object" && data.response.error === null) {
            grilabs_payment_form_submit()
        }
    }
});