function numberWithCommas(x) {
    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",")
}

$(function () {
    if ($("#quick-checkout-button-confirm").length) {
        $("#browser3dform button").hide();
    }
})
var _payment_object = null;
(function payment() {
    var d = document,
        binnumber = "000000",
        ccForm = d.getElementById("browser3dform"),
        xhr_request_active = false;

    if (ccForm !== null) {
        var cCard = d.querySelector("#cc-card"),
            ccNumber = ccForm.querySelector("#cardnumber"),
            cNumber = d.querySelectorAll(".card-number"),
            ccName = ccForm.querySelector("#cardholder"),
            cName = d.querySelectorAll(".card-holder"),
            ccMonth = ccForm.querySelector("#expires-month"),
            cMonth = d.querySelectorAll(".e-month"),
            ccYear = ccForm.querySelector("#expires-year"),
            cYear = d.querySelectorAll(".e-year"),
            ccCCV = ccForm.querySelector("#ccv"),
            cCCV = d.querySelector(".ccv strong"),
            modalCloseButton = d.querySelector(".gl--modal-close-button"),
            ccCard = d.querySelectorAll(".credit-card-type"),
            defaultNumber = cNumber[0].getElementsByTagName("span")[0].innerHTML,
            defaultName = cName[0].getElementsByTagName("span")[0].innerHTML;
    }

    init();

    function formatNumber(n) {
        return n.replace(/\D/g, "").replace(/\B(?=(\d{3})+(?!\d))/g, ",")
    }


    function ccFormInit() {
        if (typeof window.grilabs_payment_form_localize === "undefined") {
            var grilabs_payment_form_localize = {}
        }
        if (window.grilabs_payment_form_localize == null) {
            window.grilabs_payment_form_localize = {}
        }
        if (typeof window.grilabs_payment_form_localize.griform_currency_symbol === "undefined" || window.grilabs_payment_form_localize.griform_currency_symbol == null) {
            window.grilabs_payment_form_localize.griform_currency_symbol = "â‚º "
        }
        var cardType, cardNumber, cardName, cardCCV;
        addEvent(ccNumber, "focus", function () {
            cNumber[0].classList.add("glow")
        });
        addEvent(ccNumber, "blur", function () {
            cNumber[0].classList.remove("glow")
        });
        addEvent(ccName, "focus", function () {
            cName[0].classList.add("glow")
        });
        addEvent(ccName, "blur", function () {
            cName[0].classList.remove("glow")
        });
        addEvent(ccMonth, "focus", function () {
            cMonth[0].classList.add("glow")
        });
        addEvent(ccMonth, "blur", function () {
            cMonth[0].classList.remove("glow")
        });
        addEvent(ccYear, "focus", function () {
            cYear[0].classList.add("glow")
        });
        addEvent(ccYear, "blur", function () {
            cYear[0].classList.remove("glow")
        });
        addEvent(ccCCV, "focus", function () {
            cCard.classList.add("flipped")
        });
        addEvent(ccCCV, "blur", function () {
            cCard.classList.remove("flipped")
        });

        function basic_validation() {
            if (ccNumber.value.length < 17) {
                ccNumber.focus();
                return
            } else {
                if ((ccName.value).length === 0) {
                    ccName.focus();
                    return
                } else {
                    if (ccMonth.value.length === 0) {
                        ccMonth.focus();
                        return
                    } else {
                        if (ccYear.value.length === 0) {
                            ccYear.focus();
                            return
                        } else {
                            if (ccCCV.value.length < 3) {
                                ccCCV.focus();
                                return
                            }
                        }
                    }
                }
            }
            return true
        }


        grilabs_form2_submit = function () {
            if (basic_validation()) {
                grilabs_payment_form_submit()
            } else {
                if (typeof triggerLoadingOff === "function") {
                    triggerLoadingOff();
                }

                var checkout_button = document.getElementById('quick-checkout-button-confirm');
                if (checkout_button !== null) {
                    checkout_button.disabled = false;
                    checkout_button.innerHTML = checkout_button.dataset.loadingText;
                    checkout_button.classList.remove('disabled');
                }
            }
        };

        addEvent(document.querySelector("#browser3dform button"), "click", function (ev) {
            ev.preventDefault();
            grilabs_form2_submit();
        });

        priceFilter2 = function (n, suffix) {
            return parseFloat(n).toFixed(2) + suffix;
        };

        addEvent(ccNumber, "keyup,change", function () {
            cardNumber = this.value.replace(/[^0-9\s]/g, '');
            if (!!this.value.match(/[^0-9\s]/g)) {
                this.value = cardNumber;
            }
            cardType = getCardType(cardNumber.replace(/\s/g, ''));
            switch (cardType) {
                case 'amex':
                    parts = numSplit(cardNumber.replace(/\s/g, ''), [4, 6, 5]);
                    ccCard[0].className = 'credit-card-type amex';
                    break;
                case 'troy':
                    parts = numSplit(cardNumber.replace(/\s/g, ''), [4, 4, 4, 4]);
                    ccCard[0].className = 'credit-card-type troy';
                    break;
                case 'maestro':
                    parts = numSplit(cardNumber.replace(/\s/g, ''), [4, 4, 4, 4]);
                    ccCard[0].className = 'credit-card-type maestro';
                    break;

                case 'unionpay':
                    parts = numSplit(cardNumber.replace(/\s/g, ''), [4, 4, 4, 4]);
                    ccCard[0].className = 'credit-card-type unionpay';
                    break;

                case 'unionpay2':
                    parts = numSplit(cardNumber.replace(/\s/g, ''), [6, 13]);
                    ccCard[0].className = 'credit-card-type unionpay';
                    break;

                case 'mastercard':
                    parts = numSplit(cardNumber.replace(/\s/g, ''), [4, 4, 4, 4]);
                    ccCard[0].className = 'credit-card-type mastercard';
                    break;
                case 'visa':
                    parts = numSplit(cardNumber.replace(/\s/g, ''), [4, 4, 4, 4]);
                    ccCard[0].className = 'credit-card-type visa';
                    break;
                default:
                    parts = cardNumber.split(' ');
                    ccCard[0].className = 'credit-card-type';
            }

            if (this.value.length > 7) {
                if (this.value.substr(0, 7) !== binnumber) {


                    ccForm.querySelector('.loading-installments').style.display = 'block';

                    binnumber = this.value.substr(0, 7);
                    var taksitsonuc = '', row_total = 0, row_desc = '',
                        order_total = parseFloat(ccForm.dataset.total);
                    if (xhr_request_active === false) {
                        xhr_request_active = true;
                        var xhttp = new XMLHttpRequest();
                        xhttp.onreadystatechange = function () {
                            if (this.readyState == 4 && this.status == 200) {
                                taksitsonuc = JSON.parse(this.responseText);

                                if (taksitsonuc.status) {
                                    ccForm.querySelector('#installment-body').innerHTML = '';
                                    for (var item_key in taksitsonuc.installment) {
                                        if (taksitsonuc.installment[item_key] !== -1) {
                                            var obj = taksitsonuc.installment[item_key];
                                            if (item_key == 'advance')
                                                item_key = '1';
                                            item_key = item_key.split('_');
                                            item_key = item_key[0];
                                            row_total = typeof obj === "number" ? obj : parseFloat(obj);


                                            var rowtr = document.createElement('tr');
                                            rowtr.classList.add('clickable');
                                            var rowtd1 = document.createElement('td');
                                            var rowtd2 = document.createElement('td');
                                            var rowtd3 = document.createElement('td');
                                            var rowtd4 = document.createElement('td');
                                            var radioitem = document.createElement('input');

                                            radioitem.name = 'installment';
                                            radioitem.value = item_key;
                                            radioitem.type = 'radio';

                                            if (item_key == '1')
                                                radioitem.checked = true;
                                            rowtd1.width = '10%';
                                            rowtd1.appendChild(radioitem);

                                            if (item_key == 1) {
                                                rowtd2.appendChild(document.createTextNode(ccForm.dataset.advancetext));
                                                rowtd1.click();
                                            } else
                                                rowtd2.appendChild(document.createTextNode(item_key + ' ' + ccForm.dataset.installmenttext));
                                            var currency_suffix = ccForm.dataset.currencysuffix;
                                            var currency_prefix = ccForm.dataset.currencyprefix;

                                            var t1 = numberWithCommas((row_total / item_key).toFixed(2));
                                            var t2 = numberWithCommas(row_total.toFixed(2));
                                            if (typeof currency_prefix === "string") {
                                                t1 = currency_prefix + t1;
                                                t2 = currency_prefix + t2;
                                            }
                                            if (typeof currency_suffix === "string") {
                                                t1 += currency_suffix;
                                                t2 += currency_suffix;
                                            }

                                            rowtd3.appendChild(document.createTextNode(t1));
                                            rowtd4.appendChild(document.createTextNode(t2));
                                            rowtr.appendChild(rowtd1);
                                            rowtr.appendChild(rowtd2);
                                            rowtr.appendChild(rowtd3);
                                            rowtr.appendChild(rowtd4);

                                            ccForm.querySelector('#installment-body').appendChild(rowtr);

                                            // if (row_desc !== '') {
                                            //     var desc_row = document.createElement('tr');
                                            //     var desc_row_td = document.createElement('td');
                                            //     desc_row_td.colSpan = '4';
                                            //     desc_row_td.style.textAlign = 'center';
                                            //     desc_row_td.innerHTML = row_desc;
                                            //     desc_row.appendChild(desc_row_td);
                                            //     ccForm.querySelector('#installment-body').appendChild(desc_row);
                                            // }
                                        }
                                    }
                                    ccForm.querySelector('.table-installment').removeAttribute('style');
                                    rows_click_events();
                                    ccForm.querySelector('.loading-installments').style.display = 'none';
                                } else {
                                    var msg = ((typeof taksitsonuc.message !== "undefined") ? taksitsonuc.message : error_undefined);
                                    alert(msg);
                                }
                            }
                        };
                        xhr_request_active = false;
                    }
                    var check_bin_url = typeof ccForm.dataset.checkbinurl !== 'undefined' ? ccForm.dataset.checkbinurl : '';
                    check_bin_url = check_bin_url + ((check_bin_url.indexOf('?') > -1) ? '&' : '?') + "amount=" + order_total + "&bin=" + binnumber;
                    xhttp.open("GET", check_bin_url, true);
                    xhttp.send();
                }
            } else {
                if (this.value.length < 7) {
                    document.getElementById('installment-body').querySelectorAll('tr').forEach(function (labelElm) {
                        labelElm.remove();
                    });
                    binnumber = '000000';
                    ccForm.querySelector('.table-installment').style.display = 'none';
                    ccForm.querySelector('.loading-installments').style.display = 'none';
                }
            }

            cardNumber = parts.join(' ');
            if (cardNumber != this.value) {
                this.value = cardNumber;
            }

            if (!cardNumber) {
                cardNumber = defaultNumber;
            }
            syncText(cNumber, cardNumber);
        });
        addEvent(ccName, "keyup,change", function () {
            cardName = this.value.replace(/\d+|^\s+$/g, "");
            if (cardName != this.value) {
                this.value = cardName
            }
            if (!cardName) {
                cardName = defaultName
            }
            syncText(cName, cardName);
        });
        addEvent(ccMonth, "keyup,change", function (ev) {
            ev = ev || window.event;
            var month = this.value.replace(/[^0-9]/g, "");
            if (ev.keyCode == 38) {
                if (!month) {
                    month = 0
                }
                month = parseInt(month);
                month++;
                if (month < 10) {
                    month = "0" + month
                }
            }
            if (ev.keyCode == 40) {
                if (!month) {
                    month = 13
                }
                month = parseInt(month);
                month--;
                if (month == 0) {
                    month = 1
                }
                if (month < 10) {
                    month = "0" + month
                }
            }
            if (parseInt(month) > 12) {
                month = 12
            }
            if (parseInt(month) < 1 && month != 0) {
                month = "01"
            }
            if (month == "00") {
                month = "01"
            }
            if (month != this.value) {
                this.value = month
            }
            if (month.toString().length == 2) {
                syncText(cMonth, month);
                ccYear.focus()
            }
        });
        addEvent(ccYear, "keyup,change", function (ev) {
            ev = ev || window.event;
            var currentYear = new Date().getFullYear().toString().substr(2, 2),
                year = this.value.replace(/[^0-9]/g, "");
            if (ev.keyCode == 38) {
                if (!year) {
                    year = currentYear
                }
                year = parseInt(year);
                year++;
                if (year < 10) {
                    year = "0" + year
                }
            }
            if (ev.keyCode == 40) {
                if (!year) {
                    year = parseInt(currentYear) + 10
                }
                year = parseInt(year);
                year--;
                if (year < 10) {
                    year = "0" + year
                }
            }
            if (year.toString().length == 2 && parseInt(year) < currentYear) {
                year = currentYear
            }
            if (year != this.value) {
                this.value = year
            }
            if (year > (parseInt(currentYear) + 10)) {
                year = (parseInt(currentYear) + 10);
                this.value = year
            }
            if (year.toString().length == 2) {
                syncText(cYear, year);
                ccCCV.focus()
            }
        });
        addEvent(ccCCV, "keyup,change", function () {
            cardCCV = this.value.replace(/[^0-9\s]/g, "");
            if (cardCCV != this.value) {
                this.value = cardCCV
            }
            cCCV.innerHTML = cardCCV
        });
    }

    function init() {

        if (ccForm !== null)
            ccFormInit();
        _payment_object = grilabs_form2_submit;
        gl_payment_gw_menu_selection();
    }

    function syncText(elCol, text) {
        var collection;
        for (var j = 0; j < elCol.length; j++) {
            collection = elCol[j].querySelectorAll("span");
            if (!collection.length) {
                elCol[j].innerHTML = text
            } else {
                for (var i = 0; i < collection.length; i++) {
                    collection[i].innerHTML = text
                }
            }
        }
    }

    function numSplit(number, indexes) {
        var tempArr = number.split(""),
            parts = [];
        for (var i = 0, l = indexes.length; i < l; i++) {
            if (tempArr.length) {
                parts.push(tempArr.splice(0, indexes[i]).join(""))
            }
        }
        return parts
    }

    function getCardType(number) {
        var re;
        re = new RegExp("^5[1-5]");
        if (number.match(re) != null) {
            return "mastercard"
        }
        re = new RegExp("^3[47]");
        if (number.match(re) != null) {
            return "amex"
        }

        var re = new RegExp("^(365770|365771|365772|365773|650052|650082|650092|650161|650170|650173|650456|650987|654997|657366|657998|979202|979203|979204|979206|979207|979208|979209|979210|979211|979212|979213|979215|979216|979217|979218|979223|979227|979233|979235|979236|979240|979241|979242|979243|979244|979248|979249|979250|979254|979260|979261|979262|979266|979277|979278|979280)");
        if (number.match(re) != null) {
            return "troy"
        }

        var re = new RegExp("^(622648)");
        if (number.match(re) != null) {
            return "unionpay2"
        }
        var re = new RegExp("^(62)");
        if (number.match(re) != null) {
            return "unionpay"
        }
        var re = new RegExp("^(50|56|57|58|6)");
        if (number.match(re) != null) {
            return "maestro"
        }
        var re = new RegExp("^4");
        if (number.match(re) != null) {
            return "visa"
        }
        return ""
    }


    function rows_click_events() {
        var installmentRowsClick = document.querySelectorAll("#table-installment tbody tr.clickable");
        if (installmentRowsClick) {
            installmentRowsClick.forEach(function (value) {
                value.addEventListener("click", function () {
                    this.childNodes[0].childNodes[0].click()
                })
            })
        }
    }
})();

$(document).ajaxSuccess(function (event, xhr, settings, data) {
    if ((settings.url).indexOf('journal3/checkout/save') > -1 && ((typeof data.request.get.confirm === "string" && data.request.get.confirm === "true") || (typeof data.request.get.confirm === "boolean" && data.request.get.confirm === true))) {
        if (typeof data.response.error === "object" && data.response.error === null) {
            _payment_object();
        }
    }
});