<?php
class ControllerExtensionModuleStoryfeatured extends Controller {
	public function index($setting) {
		$this->load->language('extension/module/storyfeatured');

		$this->load->model('catalog/product');

		$this->load->model('tool/image');
		
		$data['products'] = array();

		if (!$setting['limit']) {
			$setting['limit'] = 10;
		}

		if (!empty($setting['product'])) {
			$products = array_slice($setting['product'], 0, (int)$setting['limit']);

			foreach ($products as $product_id) {
				$product_info = $this->model_catalog_product->getProduct($product_id);

				if ($product_info) {
					if ($this->customer->isLogged() || !$this->config->get('config_customer_price')) {
						$price = $this->currency->format($this->tax->calculate($product_info['price'], $product_info['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']);
					} else {
						$price = false;
					}

					if ((float)$product_info['special']) {
						$special = $this->currency->format($this->tax->calculate($product_info['special'], $product_info['tax_class_id'], $this->config->get('config_tax')), $this->session->data['currency']);
					} else {
						$special = false;
					}

					if ($this->config->get('config_tax')) {
						$tax = $this->currency->format((float)$product_info['special'] ? $product_info['special'] : $product_info['price'], $this->session->data['currency']);
					} else {
						$tax = false;
					}

					$data['products'][] = array(
						'product_id'  => $product_info['product_id'],
						'image'       => $product_info['image'],
						'name'        => $product_info['name'],
						'price'       => $price,
						'special'     => $special,
						'href'        => $this->url->link('product/product', 'product_id=' . $product_info['product_id'])
					);
				}
			}
		}
		
		if ($setting['delay']) {
			$data['delay'] = $setting['delay'];
		} else {
			$data['delay'] = 5;
		}
		
		if ($setting['title'] == 1) {
			$data['title'] = isset($setting['title']);
		} else {
			$data['title'] = '';
		}
		
		if ($data['products']) {
			return $this->load->view('extension/module/storyfeatured', $data);
		}
	}
}