<?php

class ControllerExtensionPaymentFzypay extends Controller
{
    public $base_url, $installment_api_url, $initialize_api_url, $complete_api_url, $return_url;


    public function index()
    {
        $this->checkAndSetCookieSameSite();
        $store_id = $this->config->get('config_store_id');
        $language_id = $this->config->get('config_language_id');


        $data['button_confirm'] = $this->language->get('button_confirm');

        $this->load->model('checkout/order');

        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        /*
         * Eğer Form türü ödeme formu ise
         */

        $url = "index.php?route=extension/payment/fzypay/start3d";

        $data['action'] = $url;
        $data['payment_fzypay_form_turu'] = $this->config->get('payment_fzypay_form_turu');
        // $callback = $this->url->link('nkolay-back-4875875454545', '', true);

        // $callback = str_replace('index.php?route=', '', $callback);
        $callback = $this->url->link('extension/payment/fzypay/callback', '', true);
        $sx = $this->config->get('payment_fzypay_sx');
        $merchantSecretKey = $this->config->get('payment_fzypay_secret');
        $successUrl = $callback;
        $failUrl = $callback;
        $amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
        $clientRefCode = $this->session->data['order_id'] . "|OP|" . uniqid();
        $productId = $this->config->get('payment_fzypay_payment');
        $use3D = $this->config->get('payment_fzypay_type') == '3D' ? 'true' : 'false';
        $rnd = date("d.m.Y H:i:s");
        $detail = "false";
        $transactionType = "SALES";

        $hashstr = $sx . $clientRefCode . $amount . $successUrl . $failUrl . $rnd . $merchantSecretKey;

        $hashData = base64_encode(pack('H*', sha1($hashstr)));

        $data['amount'] = $amount;
        $data['clientRefCode'] = $clientRefCode;
        $data['data'] = [
            'sx' => $sx,
            'successUrl' => $successUrl,
            'failUrl' => $failUrl,
            'amount' => $amount,
            'clientRefCode' => $clientRefCode,
            'productId' => $productId,
            'use3D' => $use3D,
            'rnd' => $rnd,
            'detail' => $detail,
            'transactionType' => $transactionType,
            'hashData' => $hashData,
        ];

        $base_url = explode("index.php", $_SERVER['HTTP_REFERER'])[0];
        $data['css1'] = $base_url . "catalog/view/javascript/fzypay/fzypay_form.css";
        $data['css2'] = $base_url . "catalog/view/javascript/fzypay/fzypay_icons.css";

        return $this->load->view('extension/payment/fzypay', $data);
    }

    public function callback()
    {


        $url = "https://api.fzypay.com/v1/payment/3d-secure/complete";
        if ($this->config->get('payment_fzypay_mode') == 1) {
            $url = "https://api-sandbox.fzypay.com/v1/payment/3d-secure/complete";
        }


        $merchantSecretKey = $this->config->get('payment_fzypay_secret');

        $REFERENCE_CODE = $this->request->post['REFERENCE_CODE'];
        $RESPONSE_CODE = $this->request->post['RESPONSE_CODE'];
        $USE_3D = $this->request->post['USE_3D'];
        $MERCHANT_NO = $this->request->post['MERCHANT_NO'];
        $AUTH_CODE = $this->request->post['AUTH_CODE'];
        $CLIENT_REFERENCE_CODE = $this->request->post['CLIENT_REFERENCE_CODE'];
        $AUTHORIZATION_AMOUNT = $this->request->post['AUTHORIZATION_AMOUNT'];
        $INSTALLMENT = $this->request->post['INSTALLMENT'];
        $RND = $this->request->post['RND'];
        $hashData = $this->request->post['hashData'];
        $merchantSecretKey;
        $order_id = explode('|OP|', $CLIENT_REFERENCE_CODE);

        $hashtr = $MERCHANT_NO . $REFERENCE_CODE . $AUTH_CODE . $RESPONSE_CODE . $USE_3D . $RND . $INSTALLMENT . $AUTHORIZATION_AMOUNT . $merchantSecretKey;
        $hashDatauretilen = base64_encode(pack('H*', sha1($hashtr)));


        if ($this->request->post['USE_3D'] == 'false' && $this->request->post['hashData'] == $hashDatauretilen) {


            if ($this->request->post['RESPONSE_CODE'] == 2 && $this->request->post['hashData'] == $hashDatauretilen) {
                $this->load->model('checkout/order');

                $this->model_checkout_order->addOrderHistory(current($order_id), $this->config->get('payment_fzypay_order_status_id'));
                $this->response->redirect($this->url->link('checkout/success', '', true));
            } else {
                $this->session->data['error'] = $this->request->post['RESPONSE_DATA'];

                $this->response->redirect($this->url->link('checkout/cart'));
            }
        } else {
            if ($this->request->post['RESPONSE_CODE'] == 2 && $this->request->post['hashData'] == $hashDatauretilen) {

                $ch = curl_init();
                $arrData = array(
                    "sx" => $this->config->get('payment_fzypay_sx'),
                    "referenceCode" => $REFERENCE_CODE
                );
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $arrData);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                if (is_object(json_decode($this->config->get('payment_fzypay_api_proxy')))) {
                    $proxyData = json_decode($this->config->get('payment_fzypay_api_proxy'));
                    curl_setopt($ch, CURLOPT_PROXY, $proxyData->ip);
                    curl_setopt($ch, CURLOPT_PROXYPORT, $proxyData->port);
                    curl_setopt($ch, CURLOPT_PROXYUSERPWD, $proxyData->auth);
                }
                $server_output = curl_exec($ch);

                $result = json_decode($server_output);
                $result = json_decode($result->result);

                if ($result->RESPONSE_CODE == 2) {
                    $this->load->model('checkout/order');
                    $this->model_checkout_order->addOrderHistory(current($order_id), $this->config->get('payment_fzypay_order_status_id'));
                    $this->response->redirect($this->url->link('checkout/success', '', true));
                } else {
                    $this->session->data['error'] = $result->RESPONSE_DATA;
                    $this->response->redirect($this->url->link('checkout/cart'));
                }


            } else {
                $this->session->data['error'] = $this->request->post['RESPONSE_DATA'];

                $this->response->redirect($this->url->link('checkout/cart'));
            }
        }


    }


    public function getInstall()
    {
        if ($this->config->get('payment_fzypay_mode') == 1) {
            $url = "https://api.fzypay.com/external/payments/installments";
        } else {
            $url = "https://api-sandbox.fzypay.com/external/payments/installments";
        }


        $encryptData = str_replace(" ", "", substr($_REQUEST['cardnumber'], 0, 7)) . $this->getIp();
        $json_par = json_encode(
            array(
                "BankIdentifierCode" => "",
                "Installment" => "",
                "BinNumber" => str_replace(" ", "", substr($_REQUEST['cardnumber'], 0, 7)),
                "Amount" => $_REQUEST['amount'] * 100,
            ),
            JSON_UNESCAPED_UNICODE
        );

        $result = $this->curl($json_par, $url, $encryptData);

        if (isset($result->data->cards)) {

            echo '<div class="col wid100" id="tlist">
                    <table class="table border rounded bg-white">
                        <tbody>';

            foreach ($result->data->cards as $key => $value) {
                foreach ($value->installments as $taksitler) {


                    if ($taksitler->installmentNumber == 1) {
                        $text_value = "Tek Çekim";
                    } else {
                        $text_value = $taksitler->installmentNumber . " x " . $taksitler->installmentAmount;
                    }

                    $total = $taksitler->totalAmount;

                    ?>
                    <tr>
                        <td class="px-3 py-2">
                            <div class="form-check">
                                <input
                                        type="radio"
                                        data-sayi="<?php echo $taksitler->installmentNumber ?>"
                                        id="tno<?php echo $taksitler->installmentNumber ?>"
                                        onclick="updateSubmitButtonAmount('<?php echo $total ?>')"
                                        class="form-check-input p-1"
                                        name="tno" <?php if ($taksitler->installmentNumber == 1) {
                                    echo 'checked';
                                } ?> value="<?php echo $taksitler->installmentNumber ?>"
                                        tag="<?php echo $total ?>">
                                <label class="form-check-label"
                                       for="tno<?php echo $taksitler->installmentNumber ?>"><strong><?php echo $text_value ?></strong></label>
                            </div>
                        </td>
                        <td class="px-3 py-2" id="instalmentTd<?php echo $key ?>"><label
                                    for="tno1"><?php echo $total ?> ₺ </label></td>
                        <td class="px-3 py-2 text-primary"><strong></strong></td>
                    </tr>
                    <input type="hidden" name="tsx<?php echo $taksitler->installmentNumber ?>"
                           value="<?php echo $taksitler->installmentNumber ?>">
                    <?php
                }
            }

            echo '</tbody></table></div>';
        }


    }


    public function start3d()
    {


        if ($this->config->get('payment_fzypay_mode') == 1) {
            $url = "https://api.fzypay.com/external/payments/3d-secure/initialize";
        } else {
            $url = "https://api-sandbox.fzypay.com/external/payments/3d-secure/initialize";
        }


        $amount = $this->ondalikEkle($_REQUEST['odenecek_tutar']) * 100;
        $order_id = explode("|", $_REQUEST['order_id'])[0];


        $this->load->model('checkout/order');
        $order_info = $this->model_checkout_order->getOrder($order_id);

        if ($order_info) {

            $item_data = [];
            $products = $this->model_checkout_order->getOrderProducts($order_id);

            foreach ($products as $product) {
                $item_data[] = array(
                    'id' => $product['product_id'],
                    'unitPrice' => $product['price'] * 100,
                    'name' => $product['name'],
                    'type' => "Physical",
                    'category' => "Mağaza",
                    'quantity' => $product['quantity'],
                    'TotalPrice' => $product['total'] * 100,
                );
            }
        }


        /*
         * Apiye gönderilecek parametreler
         */
        $vars = [
            'orderId' => $order_id,
            'amount' => $amount,
            'currency' => "TRY",
            'installment' => $_REQUEST['secilen_taksit'],
            'callbackUrl' => $this->url->link('extension/payment/fzypay/completePayment', '', true),
            'card' => [
                'holderName' => $_REQUEST['cardHolderName'],
                'number' => str_replace(" ", "", $_REQUEST['cardNumber']),
                'expireYear' => $_REQUEST['yil'],
                'expireMonth' => $_REQUEST['ay'],
                'cvc' => $_REQUEST['cvv'],
            ],
            'customer' => [
                'clientIp' => $this->getIp(),
                'identity' => '111111111111',
                'firstName' => $order_info['payment_firstname'],
                'lastName' => $order_info['payment_lastname'],
                'email' => $order_info['email'],
                'phoneNumber' => str_replace("+90", "", $order_info['telephone']),
                'country' => "Türkiye",
                'state' => $order_info['payment_zone'],
                'city' => $order_info['payment_city'],
                'zipCode' => '34000',
                'address' => $order_info['payment_address_1'],
            ],
            'shipping' => [
                'firstName' => $order_info['payment_firstname'],
                'lastName' => $order_info['payment_lastname'],
                'company' => 'Nocompany',
                'phoneNumber' => str_replace("+90", "", $order_info['telephone']),
                'country' => "Türkiye",
                'state' => $order_info['payment_zone'],
                'city' => $order_info['payment_city'],
                'zipCode' => '34000',
                'address' => $order_info['payment_address_1'],
            ],
            'billing' => [
                'firstName' => $order_info['payment_firstname'],
                'lastName' => $order_info['payment_lastname'],
                'company' => 'Nocompany',
                'phoneNumber' => str_replace("+90", "", $order_info['telephone']),
                'email' => $order_info['email'],
                'country' => "Türkiye",
                'state' => $order_info['payment_zone'],
                'city' => $order_info['payment_city'],
                'zipCode' => '34000',
                'address' => $order_info['payment_address_1'],
            ],
            'orderItems' => $item_data,
            'callbackType' => 'Post'

        ];


        $json_par = json_encode($vars);
        $encryptData = $order_id . $amount . $this->url->link('extension/payment/fzypay/completePayment', '', true);
        $result = $this->curl($json_par, $url, $encryptData);
        if($result->succeeded){
            print_r($result->data->form3d);
        } else {
            $this->session->data['error'] = implode('<br>', $result->errorInfo->message);
            $this->response->redirect($this->url->link('checkout/checkout'));
        }
    }

    /*
     * 3d ödemeyi tamamlar ve ödeme başarılı sayfasına yönlendirir
     */
    public function completePayment()
    {

        $url = "https://api.fzypay.com/external/payments/inquiry";
        if ($this->config->get('payment_fzypay_mode') == 0) {
            $url = "https://api-sandbox.fzypay.com/external/payments/inquiry";
        }

        $json_par = json_encode(array(
            'paymentId' => $_REQUEST['paymentId'],
            'orderId' => $_REQUEST['orderId'],
        ));
        $hash_data = $_REQUEST['paymentId'] . $this->getIp();
        $result = $this->curl($json_par, $url, $hash_data);


        if ($result->data->status == "Sale") {
            $order_id = $result->data->orderId;
            $this->load->model('checkout/order');
            $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_fzypay_order_status_id'));
            $this->response->redirect($this->url->link('checkout/success', '', true));
        } else {

            $this->session->data['error'] = $result->data->message;
            $this->response->redirect($this->url->link('checkout/checkout'));
        }
        exit;

    }


    public function generateHash($apiKey, $apiSecret, $random, $dataToEncrypt)
    {
        $computedHashAsHex = hash_hmac('SHA256', $dataToEncrypt, utf8_encode($apiSecret));
        $authorizationString = sprintf("APIKey:%s&Random:%s&Signature:%s", $apiKey, $random, $computedHashAsHex);
        $result = base64_encode($authorizationString);
        return $result;
    }


    public function curl($json_par, $url, $encryptData)
    {
        $random = "23Ab?321";
        $hash = $this->generateHash($this->config->get('payment_fzypay_api_key'), $this->config->get('payment_fzypay_api_secret'), $random, $encryptData);
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_SSL_VERIFYPEER => false,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => $json_par,
            CURLOPT_HTTPHEADER => array(
                sprintf('clientIpAddress:%s', $this->getIp()),
                sprintf('ApiKey:%s', $this->config->get('payment_fzypay_api_key')),
                sprintf('Random:%s', $random),
                sprintf('Hash:%s', $hash),
                'Content-Type: application/json;charset=utf-8'
            ),
        ));


        $proxyData = stripslashes(html_entity_decode($this->config->get('payment_fzypay_api_proxy')));
        $proxyData = json_decode($proxyData);
        curl_setopt($curl, CURLOPT_PROXY, $proxyData->ip);
        curl_setopt($curl, CURLOPT_PROXYPORT, $proxyData->port);
        curl_setopt($curl, CURLOPT_PROXYUSERPWD, $proxyData->auth);


        $response = curl_exec($curl);
        curl_close($curl);
        return json_decode($response);
    }

    private function getIp()
    {
        if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
            $ip = $_SERVER['HTTP_CLIENT_IP'];
        } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
        } else {
            $ip = $_SERVER['REMOTE_ADDR'];
        }

        return $ip;
    }

    public function ondalikEkle($total)
    {
        if (empty(explode(".", $total)[1])) {
            $total = $total . ".00";
        } else {
            if (strlen(explode(".", $total)[1]) == 1) {
                $total = $total . "0";
            }
        }
        return $total;
    }

    private function setcookieSameSite($name, $value, $expire, $path, $domain, $secure, $httponly)
    {

        if (PHP_VERSION_ID < 70300) {

            setcookie($name, $value, $expire, "$path; samesite=None", $domain, $secure, $httponly);
        } else {
            setcookie($name, $value, [
                'expires' => $expire,
                'path' => $path,
                'domain' => $domain,
                'samesite' => 'None',
                'secure' => $secure,
                'httponly' => $httponly
            ]);


        }
    }

    private function checkAndSetCookieSameSite()
    {

        $checkCookieNames = array('PHPSESSID', 'OCSESSID', 'default', 'PrestaShop-', 'wp_woocommerce_session_');

        foreach ($_COOKIE as $cookieName => $value) {
            foreach ($checkCookieNames as $checkCookieName) {
                if (stripos($cookieName, $checkCookieName) === 0) {
                    $this->setcookieSameSite($cookieName, $_COOKIE[$cookieName], time() + 86400, "/", $_SERVER['SERVER_NAME'], true, true);
                }
            }
        }
    }
}